.TH lpsd 1 "Private daemon to service remote lps requests" "X11R4"
.SH Name
lpsd \- A private tcp/ip daemon to service remote lps data requests.
.SH Description
lpsd is almost an exact copy of the Berkeley lpd daemon, with several major
exceptions. First of all this program requires that tcp/ip service socket
516 be dedicated to the use of the lps system set of programs. Secondly,
while the lpd program scans the input packet for a request, processes that
request and then exits, \fIlpsd\fP goes into an endless loop, continuously
processing all incomming requests until an error occurs on the socket, or
the socket times out.

.SH Syntax
\fIlpsd\fP should be started from /etc/rc.local at system boot time.
.SH Options
None.
.SH Example
The following segment of script should be appended to the end of
/etc/rc.local:
.EX
# Start up Printer Monitoring Daemon, lpsd
echo 'Starting lpsd'                                    >/dev/console
if [ -f /usr/local/lib/lpsd ]; then
        /usr/local/lib/lpsd 2>&1 &                      >/dev/console
fi
.EE
.SH Environment
This suite of programs has been built and run under most SunOs and DEC
ULTRIX systems using TWM and TVWM window managers. Running the program
under Motif or OpenLook can produce some weird results, depending on the
settings of certain(??) window manager variables. We have not attempted to
run these programs under the DECWINDOWS Window Manager.

.SH See Also
lps(1), lpsV2(1), server(1)
.SH Errors
All error messages are sent to both stderr and the system error logs.
.SH Copyright
1991 at NASA-Ames Research Center. Some portions of this program were
taken from the Berkeley spooler programs and from certain programs
contained in the MIT X11R4 release. Individual copyrights have been
reproduced for those portions affected.
.SH Author
.EX
Roger Smith
NASA-Ames Research Center
Mail Stop 233-10
Moffett Field, Ca. 94035
EMAIL: rsmith@george.arc.nasa.gov

REFER ANY PROBELMS OR BUG REPORTS TO:
	Roger Smith  x4-3583 or rsmith@george.arc.nasa.gov
	Ken Burgess  x4-6347 or kburgess@franklin.arc.nasa.gov
.EE

.SH Release
V1 October, 1990
