.TH lpinfo 1 "Return a list of /etc/printcap information" "X11R4"
.SH Name
lpinfo \- Return a formatted string of information from /etc/printcap based
on a user specified filter.
.SH Description
This program was written to service shell scripts and pipes that required
filtered information from /etc/printcap. The program returns a formatted
string of information based on the filter specified in the users command line.
.SH Syntax
lpinfo [-] [[Qq][Tt][Pp][Dd][Ll][Rr][Hh]]
.SH Options
.TP 8
[-][Qq] List all queue names (Default)
.TP 8
[-][Qq] \fIdev\fP Return all queue names assigned to device \fIdev\fP
.TP 8
[-][Tt] List all non-production queue names
This switch depends on the convention that all production queues have names
that start with cpf..... and all test (or non-production) queue names begin
with test.....
.TP 8
[-][Pp] List all Production queue names only.
.TP 8
[-][Dd] List all devices assigned in /etc/printcap
.TP 8
[-][Dd] \fIque\fP  Return device assignment for queue \fIque\fP
.TP 8
[-][Ll] List only local devices assigned by printcap.
.TP 8
[-][Rr] List only remote devices assigned by printcap.
.TP 8
[-][Hh] Print a list of command line options.
.SH Example
lpinfo t
.br
might return a list such as:
.br
test1 test2 testlp
.SH See Also
.EX
lpsV2(1), editprintcap(1), starter(1), server(1), lpsd(1), 

.SH Author
.EX
Roger Smith
NASA-Ames Research Center
Mail Stop 233-10
Moffett Field, Ca. 94035
EMAIL: rsmith@george.arc.nasa.gov

REFER ANY PROBELMS OR BUG REPORTS TO:
	Roger Smith  x4-3583 or rsmith@george.arc.nasa.gov
	Ken Burgess  x4-6347 or kburgess@franklin.arc.nasa.gov
.EE

