
#include "../lp.h"
#include "../lps.h"
#include <ctype.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/Xaw/XawInit.h>
#include <X11/Xaw/LabelP.h>
#include <X11/Xaw/FormP.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#ifndef ENOENT
#include <errno.h>
#endif
#ifndef NULL
#define NULL 0
#endif
/*
 *  So that we can use fprintf:
 */
#include <stdio.h>

#define MAX_BUFFERS MAX_QUEUES

extern Widget topLevel;
int ret_width, ret_height;

XtIntervalId bellID;
Bool    bell=OFF;

struct output_age {
    char   printer[16];
    int    numJobs;
    int    oldestJob;
};

struct databuf{
    char    queNames[MAX_QUEUES][MAX_QUEUES];
    int     queingEna[MAX_QUEUES];
    int     printEna[MAX_QUEUES];
    int	    nitems;
    int     numEntries[MAX_QUEUES];
    int     oldestJob[MAX_QUEUES];
    int     daemonPresent[MAX_QUEUES];
    char    assigned_to[MAX_QUEUES][MAX_QUEUES];
    char    status[MAX_QUEUES][80];
    char    qdata[MAX_QUEUES][7][64];
    time_t  mtime[MAX_BUFFERS];				    /* time stamp for each of the data buffers */
    struct  output_age data[MAX_BUFFERS];
    int     numPrinters;
    time_t  oldestJobTime[MAX_BUFFERS];
}*buf0;

struct old_databuf{
    char    queNames[MAX_QUEUES][MAX_QUEUES];
    int     queingEna[MAX_QUEUES];
    int     printEna[MAX_QUEUES];
    int     numEntries[MAX_QUEUES];
    int     oldestJob[MAX_QUEUES];
    int     daemonPresent[MAX_QUEUES];
    char    assigned_to[MAX_QUEUES][MAX_QUEUES];
    char    status[MAX_QUEUES][80];
    struct  output_age data[MAX_BUFFERS];
    int     numPrinters;
}*old_buf0;

time_t  mtime[MAX_BUFFERS];
char * status_page[MAX_BUFFERS];

void getformWnH(lw)
FormWidget lw;
{
    ret_width = lw->core.width;
    ret_height = lw->core.height;
}

void mygetvalues(lw)
LabelWidget lw;
{
    register XFontStruct  *fs = lw->label.font;

    printf("ascent=%d, descent=%d, label_height=%d\n",
	   fs->max_bounds.ascent, 
	   fs->max_bounds.descent, 
	   lw->label.label_height);
}

void Syntax(argc, argv)
int argc;
char * argv[];
{
    int i;
    static int errs = FALSE;
    for (i=1; i<argc; i++) {
	if (!errs++)		/* for first time through */
	    fprintf(stderr, "%s: command line option %s unknown:\n", argv[0], argv[i]);
    }
    fprintf(stderr, "%s understands all standard Xt command line options.\n", argv[0]);

    fprintf(stderr, "Additional options are:\n");
    fprintf(stderr, "OPTION       FUNCTION                VALID RANGE      DEFAULT\n");
    fprintf(stderr, "-interval n  update interval         1 to 60 seconds  1 second\n");
    fprintf(stderr, "-count n     quit after n updates    1 to 1000        0 (no limit)\n");
    exit();
}

