.TH xlps_server 1 "Data Server for LPS" "X11R4"
.SH Name
xlps_server \- Data Server for the lps client/server set of programs.
.SH Description
\fIxlps_server\fP is the data server portion of a three piece
client/server set of programs. The other two parts of the set are
\fIstarter\fP and \fIlps\fP.
.PP
\fIxlps_server\fP is almost transparent to the average user.  As long as an
invocation of \fIxlps_server\fP is active it will support any number of client
\fIlps\fP programs.  If \fIxlps_server\fP is not running, then any attempt to
launch an invocation of \fIlps\fP will fail with an error message. In that
event the user should attempt to jumpstart the whole system by using starter(1)
.SH Syntax
\fIxlps_server\fP can be (re)started at anytime by a suitably privileged user.
Depending on how the image is installed (i.e., set UID root), it is possible for any
non-privileged user to launch the \fIxlps_server\fP. The program does not
require, nor will it honor, any command line switches or options.
.SH Environment
\fIxlps_server\fP requires that the Berkeley IPC package or its equivalent be
available and functional, and further requires that the system imposed
limit on the number of active shared memory buffers be raised to equal the
number of entries in /etc/printcap. If
this is not the case, the program will abort with fatal error message #24
"Too many open files". Xlps_Server also requires 2 active semaphores per queue, and
will fail with a fatal error msg of "No Space left on device" if there are not
enough semaphores.  See the installation instructions in the README file at the
top of the destribution tree.
.PP
\fIxlps_server\fP also requires a private daemon \fIlpsd\fP which must be
running and should be started in rc.local. See the man page lpsd(1).
.SH See Also
lps(1), lpsd(1), ipcs(1), showSemaphores(1)
.SH Errors
Most error messages are sent to the stderr on the invoking terminal. Some
additional error and status information is written to the system error logs.
.SH Copyright
1991 at NASA-Ames Research Center. Some portions of this program were
taken from the Berkeley spooler programs and from certain programs
contained in the MIT X11R4 release. Individual copyrights have been
reproduced for those portions affected.
.SH Author
.EX
Roger Smith
NASA-Ames Research Center
Mail Stop 233-10
Moffett Field, Ca. 94035
EMAIL: rsmith@george.arc.nasa.gov

REFER ANY PROBELMS OR BUG REPORTS TO:
	Roger Smith  x4-3583 or rsmith@george.arc.nasa.gov
	Ken Burgess  x4-6347 or kburgess@franklin.arc.nasa.gov
.EE

.SH Release
V2.0a April 1991
